<?php

namespace Drupal\payson_checkout;

use Symfony\Component\HttpFoundation\Request;

/**
 * Provides a handler for Payson requests.
 */
interface PaysonHandlerInterface {

/*
 * Constructor - initialises with payment gateway plugin
 * 
 * @param \Drupal\commerce_payment\Plugin\Commerce\PaymentGateway\OffsitePaymentGatewayInterface $payment_gateway_plugin 
 *   Payment Gateway interface for the request.
 * 
 */
 public function __construct($payment_gateway_plugin);
  
  /**
   * Creates an authorisation string .
   *
   * @return string
   *   The base64 encoded string used for authorisation.
   *
   * @throws \Symfony\Component\HttpKernel\Exception\HttpException
   */
  public function authorisationString();

/*
 * Get correct url for API calls depending on mode. 
 * 
 * @return string
 *    String with url to environment at Payson dependng on mode (Live or dev).
 */
  public function apiUrl();
  
}
